#include "467gpu.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
// Disassembler

int main(int argc, char *argv[]) {
    FILE    *infp = stdin;
    FILE    *outfp = stdout;
    int     i;
    
    i = 1;
    while (i < argc) {
        if (argv[i][0] == '-') {
            switch(argv[i][1]) {
                case    'i':
                case    'I':
                    infp = fopen(argv[i + 1], "r");
                    if (!infp) {
                        printf("Failure to open input file: %s\n", argv[i + 1]);
                        exit(__LINE__);
                    }
                    i += 2;
                    break;
                case    'o':
                case    'O':
                    outfp = fopen(argv[i + 1], "w");
                    if (!outfp) {
                        printf("Failure to create output file: %s\n", argv[i + 1]);
                        exit(__LINE__);
                    }
                    i += 2;
                    break;
                default:
                    printf("Usage:\n"
                        "\t-i <input>     input file\n"
                        "\t-o <output>    output file\n");
                    exit(__LINE__);
            }
        } else {
            printf("Try -- for help\n");
            exit(__LINE__);
        }
    }

    u_int32_t   res;
    char    s[MAX_LINE_LENGTH];
    
    while (!feof(infp)) {
        if (fread(&res, 1, sizeof(res), infp) != sizeof(res))
            break;
        
        if (!disasm_instruction(res, s)) {
            printf("Corrupt object file: %8.8x\n", res);
            exit(__LINE__);
        }
        
        fprintf(stdout, "    %s\n", s);
    }
    
    if (infp != stdin)
        fclose(infp);
    if (outfp != stdout)
        fclose(outfp);
        
    return 0;
}
